package org.example;

import java.util.Random;
import java.util.Scanner;

import static org.example.BeatThemAllGame.chooseHero;
import static org.example.BeatThemAllGame.generateRandomEnemy;
import static org.example.BeatThemAllGame.getRandomItem;

public class Main {

    // afficher le titre (on pourra changer l'ascii)
    public static void displayTitle() {
        System.out.println("**************************************************");
        System.out.println("*                 BEAT THEM ALL                  *");
        System.out.println("**************************************************");
        System.out.println("          ____        _   _   _                  ");
        System.out.println("         |  _ \\      | | | | | |                 ");
        System.out.println("         | |_) | __ _| |_| |_| | ___             ");
        System.out.println("         |  _ < / _` | __| __| |/ _ \\            ");
        System.out.println("         | |_) | (_| | |_| |_| |  __/            ");
        System.out.println("         |____/ \\__,_|\\__|\\__|_|\\___|            ");
        System.out.println();
    }

    // pareil qu'au dessus
    public static void displayGameOver() {
        System.out.println("\n=== VOUS ÊTES MORT ===");
        System.out.println("      _____");
        System.out.println("     /     \\");
        System.out.println("    |       |");
        System.out.println("    |  RIP  |");
        System.out.println("    |       |");
        System.out.println("    |       |");
        System.out.println("    |       |");
        System.out.println("    |_______|");
        System.out.println("\nMerci d'avoir joué !");
    }

    public static void main(String[] args) {
        Test.runTests();
        Scanner scanner = new Scanner(System.in);
        displayTitle();

        Hero hero = chooseHero(scanner);
        System.out.println();

        System.out.println("Votre aventure commence !");
        Logger.getInstance().log("Début de l'aventure de " + hero.name);

        boolean gameRunning = true;
        while (gameRunning && hero.isAlive()) {
            Enemy enemy = generateRandomEnemy();
            System.out.println("\nUn " + enemy.name + " apparaît !");
            Logger.getInstance().log(hero.name + " rencontre un " + enemy.name);
            Battle.battle(scanner, hero, enemy);
            if (!hero.isAlive()) {
                displayGameOver();
                Logger.getInstance().log(hero.name + " est mort");
                break;
            }
            hero.resetSpecialAbility();
            hero.gainExperience(50);

            // Chance de trouver un objet après le combat
            if (new Random().nextInt(100) < 50) {
                Item foundItem = getRandomItem();
                System.out.println("Vous trouvez un objet sur l'ennemi !");
                hero.addItem(foundItem);
            }

            // Demander au joueur s'il veut continuer
            System.out.print("\nVoulez-vous continuer ? (oui/non) : ");
            String choice = scanner.next();
            if (!choice.equalsIgnoreCase("oui")) {
                gameRunning = false;
                System.out.println("Merci d'avoir joué !");
                Logger.getInstance().log(hero.name + " a quitté le jeu");
            }
        }
    }
}